//+------------------------------------------------------------------+
//|                                                   HaosVisual.mq4 |
//|                                               original by mrslav |
//|                                           this version by mladen |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Lime
#property indicator_color2 Coral
#property indicator_width2 2
#property indicator_color3 Coral
#property indicator_width3 2
#property indicator_color4 Lime
#property indicator_width4 2
#property indicator_color5 Lime
#property indicator_width5 2
#property indicator_color6 DodgerBlue
#property indicator_color7 DarkGoldenrod
#property indicator_width7 2
#property indicator_maximum 50
#property indicator_minimum -50

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern string          WPR1            = "*** WPR1 ***";
extern int             t3_period       = 8;
extern double          b               = 0.7;
extern int             per             = 14;
extern int             psel            = 30;
extern int             pbuy            = -30;
extern string          WPR2            = "*** WPR2 ***";
extern int             t3_period_2     = 8;
extern double          b_2             = 0.7;
extern int             per_2           = 96;
extern int             psel_2          = 40;
extern int             pbuy_2          = -40;
extern bool            alertsOn        = false;
extern bool            alertsOnCurrent = true;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsNotify    = false;
extern bool            alertsEmail     = false;
extern string          soundFile       = "alert2.wav";

double Buffer1[];
double Buffer2[];
double Dn2[];
double Dn1[];
double Mid[];
double Up1[];
double Up2[];
string indicatorFileName;
bool   returnBars;
//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init() 
{
   SetIndexBuffer(0,Buffer2); SetIndexLabel(0,"  ");
   SetIndexBuffer(1,Up1);     SetIndexLabel(1," ");
   SetIndexBuffer(2,Dn1);     SetIndexLabel(2," ");
   SetIndexBuffer(3,Up2);     SetIndexLabel(3," ");
   SetIndexBuffer(4,Dn2);     SetIndexLabel(4,"  ");
   SetIndexBuffer(5,Mid); 
   SetIndexBuffer(6,Buffer1); SetIndexLabel(6,"  ");
      SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexStyle(4,DRAW_HISTOGRAM);
      SetIndexStyle(5,DRAW_HISTOGRAM);
      SetLevelValue(0,psel_2);
      SetLevelValue(1,psel);
      SetLevelValue(2,0);
      SetLevelValue(3,pbuy);
      SetLevelValue(4,pbuy_2);

      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);

   IndicatorShortName(timeFrameToString(TimeFrame)+" Haos Visual");
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Buffer2[0] = limit+1; return(0); }
       
   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
     for (int i=limit; i>=0; i--)
     {
         Buffer1[i] = iT3(iWPR(NULL,0,per,i)  ,t3_period  ,b  ,false,i,0)+50;
         Buffer2[i] = iT3(iWPR(NULL,0,per_2,i),t3_period_2,b_2,false,i,1)+50;
         Up2[i]=EMPTY_VALUE; 
   	   Dn1[i]=EMPTY_VALUE; 
	      Up1[i]=EMPTY_VALUE; 
	      Dn2[i]=EMPTY_VALUE; 
         Mid[i]=EMPTY_VALUE; 


           if (Buffer1[i]> psel && Buffer2[i]>psel_2) Dn2[i]=Buffer2[i];
      else if (Buffer1[i]<=psel && Buffer2[i]>psel_2) Dn1[i]=Buffer2[i];
	   else if (Buffer1[i]< pbuy && Buffer2[i]<pbuy_2) Up2[i]=Buffer2[i];
	   else if (Buffer1[i]>=pbuy && Buffer2[i]<pbuy_2) Up1[i]=Buffer2[i];
      else                                            Mid[i]=Buffer2[i];
      }
      
    //
    //
    //
    //
    //
    
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,TimeFrame,whichBar)); 
      
      //
      //
      //
      //
      //
      
      if (Dn2[whichBar+1] == EMPTY_VALUE && Dn2[whichBar] != EMPTY_VALUE) doAlert(whichBar,"strong sell");
      if (Dn1[whichBar+1] == EMPTY_VALUE && Dn1[whichBar] != EMPTY_VALUE) doAlert(whichBar,"weak sell");
      if (Up2[whichBar+1] == EMPTY_VALUE && Up2[whichBar] != EMPTY_VALUE) doAlert(whichBar,"strong buy");
      if (Up1[whichBar+1] == EMPTY_VALUE && Up1[whichBar] != EMPTY_VALUE) doAlert(whichBar,"weak buy");
    }         
      return(0); 
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         Buffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,6,y);
         Buffer2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
         Up1[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
         Dn1[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,2,y);
         Up2[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);
         Dn2[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,4,y);
         Mid[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",t3_period,b,per,psel,pbuy,"",t3_period_2,b_2,per_2,psel_2,pbuy_2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,5,y);
   }   
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workT3[][12];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) !=Bars)                 ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(TimeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Haos Visual ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Haos Visual "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}


